/*******************************************************************
*
*  DESCRIPTION:
*
*  AUTHOR:
*
*  EMAIL:
*
*  DATE:
*
*******************************************************************/

#ifndef __COUNTER_H
#define __COUNTER_H

#include <list>
#include "atomic.h"     // class Atomic

class Counter : public Atomic
{
public:
	Counter( const string &name = "Counter" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &moveLeft;
	const Port &moveRight;
	const Port &incr;
	const Port &decr;
	Port &aisleLocked;
	Port &onExit;
	Time preparationTime;
	Time initialTime;
	int countValue;
	bool ifLocked;
	bool ifExit;


};	// class Counter

// ** inline ** //
inline
string Counter::className() const
{
	return "Counter" ;
}

#endif   //__COUNTER_H
